diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/stats/model/sqlite-data-output.cc ns-3.31/src/stats/model/sqlite-data-output.cc
--- ns-3.30.1/src/stats/model/sqlite-data-output.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/stats/model/sqlite-data-output.cc	2020-06-27 17:38:30.000000000 -0700
@@ -18,30 +18,28 @@
  * Author: Joe Kopena (tjkopena@cs.drexel.edu)
  */
 
+#include "sqlite-data-output.h"
 #include <sstream>
 
-#include <sqlite3.h>
-
 #include "ns3/log.h"
 #include "ns3/nstime.h"
 
 #include "data-collector.h"
 #include "data-calculator.h"
-#include "sqlite-data-output.h"
+#include "sqlite-output.h"
 
-using namespace ns3;
+namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("SqliteDataOutput");
 
-//--------------------------------------------------------------
-//----------------------------------------------
-SqliteDataOutput::SqliteDataOutput()
+SqliteDataOutput::SqliteDataOutput ()
+  : DataOutputInterface ()
 {
   NS_LOG_FUNCTION (this);
 
   m_filePrefix = "data";
 }
-SqliteDataOutput::~SqliteDataOutput()
+SqliteDataOutput::~SqliteDataOutput ()
 {
   NS_LOG_FUNCTION (this);
 }
@@ -55,60 +53,6 @@
     .AddConstructor<SqliteDataOutput> ();
   return tid;
 }
-  
-void
-SqliteDataOutput::DoDispose ()
-{
-  NS_LOG_FUNCTION (this);
-
-  DataOutputInterface::DoDispose ();
-  // end SqliteDataOutput::DoDispose
-}
-
-int
-SqliteDataOutput::Exec (std::string exe) {
-  NS_LOG_FUNCTION (this << exe);
-
-  int res;
-  char **result;
-  int nrows, ncols;
-  char *errMsg = 0;
-
-  NS_LOG_INFO ("executing '" << exe << "'");
-
-  res = sqlite3_get_table (m_db,
-                           exe.c_str (),
-                           &result, &nrows, &ncols,
-                           &errMsg);
-
-  if (res != SQLITE_OK) {
-      NS_LOG_ERROR ("sqlite3 error: \"" << errMsg << "\"");
-      /*
-      } else {
-        // std::cout << "nrows " << nrows << " ncols " << ncols << std::endl;
-
-        if (nrows > 0) {
-          for (int i = 0; i < ncols; i++) {
-            std::cout << "  " << result[i];
-          }
-          std::cout << std::endl;
-
-          for (int r = 1; r <= nrows; r++) {
-            for (int c = 0; c < ncols; c++) {
-              std::cout << "  " << result[(r*ncols)+c];
-            }
-            std::cout << std::endl;
-          }
-          std::cout << std::endl;
-        }
-      */
-    }
-
-  sqlite3_free_table (result);
-  return res;
-
-  // end SqliteDataOutput::Exec
-}
 
 //----------------------------------------------
 void
@@ -117,97 +61,90 @@
   NS_LOG_FUNCTION (this << &dc);
 
   std::string m_dbFile = m_filePrefix + ".db";
+  std::string run = dc.GetRunLabel ();
+  bool res;
 
-  if (sqlite3_open (m_dbFile.c_str (), &m_db)) {
-      NS_LOG_ERROR ("Could not open sqlite3 database \"" << m_dbFile << "\"");
-      NS_LOG_ERROR ("sqlite3 error \"" << sqlite3_errmsg (m_db) << "\"");
-      sqlite3_close (m_db);
-      /// \todo Better error reporting, management!
-      return;
-    }
+  m_sqliteOut = new SQLiteOutput (m_dbFile, "ns-3-sqlite-data-output-sem");
 
-  Exec ("create table if not exists Experiments (run, experiment, strategy, input, description text)");
+  res = m_sqliteOut->SpinExec ("CREATE TABLE IF NOT EXISTS Experiments (run, experiment, strategy, input, description text)");
+  NS_ASSERT (res);
 
   sqlite3_stmt *stmt;
-  sqlite3_prepare_v2 (m_db,
-    "insert into Experiments (run, experiment, strategy, input, description) values (?, ?, ?, ?, ?)",
-    -1,
-    &stmt,
-    NULL
-  );
+  res = m_sqliteOut->WaitPrepare (&stmt,
+                                  "INSERT INTO Experiments " \
+                                  "(run, experiment, strategy, input, description)" \
+                                  "values (?, ?, ?, ?, ?)");
+  NS_ASSERT (res);
+
+  res = m_sqliteOut->Bind (stmt, 1, run);
+  NS_ASSERT (res);
+  res = m_sqliteOut->Bind (stmt, 2, dc.GetExperimentLabel ());
+  NS_ASSERT (res);
+  res = m_sqliteOut->Bind (stmt, 3, dc.GetStrategyLabel ());
+  NS_ASSERT (res);
+  res = m_sqliteOut->Bind (stmt, 4, dc.GetInputLabel ());
+  NS_ASSERT (res);
+  res = m_sqliteOut->Bind (stmt, 5, dc.GetDescription ());
+  NS_ASSERT (res);
+
+  res = m_sqliteOut->SpinStep (stmt);
+  NS_ASSERT (res);
+  res = m_sqliteOut->SpinFinalize (stmt);
+  NS_ASSERT (res);
+
+  res = m_sqliteOut->WaitExec ("CREATE TABLE IF NOT EXISTS " \
+                               "Metadata ( run text, key text, value)");
+  NS_ASSERT (res);
+
+  res = m_sqliteOut->WaitPrepare (&stmt,
+                                  "INSERT INTO Metadata " \
+                                  "(run, key, value)" \
+                                  "values (?, ?, ?)");
+  NS_ASSERT (res);
 
-  std::string run = dc.GetRunLabel ();
-  sqlite3_bind_text (stmt, 1, run.c_str (), run.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (stmt, 2, dc.GetExperimentLabel ().c_str (),
-                              dc.GetExperimentLabel ().length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (stmt, 3, dc.GetStrategyLabel ().c_str (),
-                              dc.GetStrategyLabel ().length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (stmt, 4, dc.GetInputLabel ().c_str (),
-                              dc.GetInputLabel ().length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (stmt, 5, dc.GetDescription ().c_str (),
-                              dc.GetDescription ().length (), SQLITE_TRANSIENT);
-  sqlite3_step (stmt);
-  sqlite3_finalize (stmt);
-
-  Exec ("create table if not exists Metadata ( run text, key text, value)");
-
-  sqlite3_prepare_v2 (m_db,
-    "insert into Metadata (run, key, value) values (?, ?, ?)",
-    -1,
-    &stmt,
-    NULL
-  );
   for (MetadataList::iterator i = dc.MetadataBegin ();
-       i != dc.MetadataEnd (); i++) {
+       i != dc.MetadataEnd (); i++)
+    {
       std::pair<std::string, std::string> blob = (*i);
-
-      sqlite3_reset (stmt);
-      sqlite3_bind_text (stmt, 1, run.c_str (),
-                                  run.length (), SQLITE_TRANSIENT);
-      sqlite3_bind_text (stmt, 2, blob.first.c_str (),
-                                  blob.first.length (), SQLITE_TRANSIENT);
-      sqlite3_bind_text (stmt, 3, blob.second.c_str (),
-                                  blob.second.length (), SQLITE_TRANSIENT);
-      sqlite3_step (stmt);
+      m_sqliteOut->SpinReset (stmt);
+      m_sqliteOut->Bind (stmt, 1, run);
+      m_sqliteOut->Bind (stmt, 2, blob.first);
+      m_sqliteOut->Bind (stmt, 3, blob.second);
+      m_sqliteOut->SpinStep (stmt);
     }
-  sqlite3_finalize (stmt);
 
-  Exec ("BEGIN");
-  SqliteOutputCallback callback (this, run);
+  m_sqliteOut->SpinFinalize (stmt);
+
+  m_sqliteOut->SpinExec ("BEGIN");
+  SqliteOutputCallback callback (m_sqliteOut, run);
   for (DataCalculatorList::iterator i = dc.DataCalculatorBegin ();
-       i != dc.DataCalculatorEnd (); i++) {
+       i != dc.DataCalculatorEnd (); i++)
+    {
       (*i)->Output (callback);
     }
-  Exec ("COMMIT");
-
-  sqlite3_close (m_db);
-
+  m_sqliteOut->SpinExec ("COMMIT");
   // end SqliteDataOutput::Output
 }
 
 SqliteDataOutput::SqliteOutputCallback::SqliteOutputCallback
-  (Ptr<SqliteDataOutput> owner, std::string run) :
-  m_owner (owner),
-  m_runLabel (run)
-{
-  NS_LOG_FUNCTION (this << owner << run);
-
-  m_owner->Exec ("create table if not exists Singletons ( run text, name text, variable text, value )");
-
-  sqlite3_prepare_v2 (m_owner->m_db,
-    "insert into Singletons (run, name, variable, value) values (?, ?, ?, ?)",
-    -1,
-    &m_insertSingletonStatement,
-    NULL
-  );
-  sqlite3_bind_text (m_insertSingletonStatement, 1, m_runLabel.c_str (), m_runLabel.length (), SQLITE_TRANSIENT);
-
-  // end SqliteDataOutput::SqliteOutputCallback::SqliteOutputCallback
+  (const Ptr<SQLiteOutput> &db, std::string run)
+  : m_db (db),
+    m_runLabel (run)
+{
+  NS_LOG_FUNCTION (this << db << run);
+
+  m_db->WaitExec ("CREATE TABLE IF NOT EXISTS Singletons " \
+                  "( run text, name text, variable text, value )");
+
+  m_db->WaitPrepare (&m_insertSingletonStatement, "INSERT INTO Singletons " \
+                     "(run, name, variable, value)" \
+                     "values (?, ?, ?, ?)");
+  m_db->Bind (m_insertSingletonStatement, 1, m_runLabel);
 }
 
 SqliteDataOutput::SqliteOutputCallback::~SqliteOutputCallback ()
 {
-  sqlite3_finalize (m_insertSingletonStatement);
+  m_db->SpinFinalize (m_insertSingletonStatement);
 }
 
 void
@@ -217,17 +154,27 @@
 {
   NS_LOG_FUNCTION (this << key << variable << statSum);
 
-  OutputSingleton (key,variable+"-count", (double)statSum->getCount ());
+  OutputSingleton (key,variable + "-count", static_cast<double> (statSum->getCount ()));
   if (!isNaN (statSum->getSum ()))
-    OutputSingleton (key,variable+"-total", statSum->getSum ());
+    {
+      OutputSingleton (key,variable + "-total", statSum->getSum ());
+    }
   if (!isNaN (statSum->getMax ()))
-    OutputSingleton (key,variable+"-max", statSum->getMax ());
+    {
+      OutputSingleton (key,variable + "-max", statSum->getMax ());
+    }
   if (!isNaN (statSum->getMin ()))
-    OutputSingleton (key,variable+"-min", statSum->getMin ());
+    {
+      OutputSingleton (key,variable + "-min", statSum->getMin ());
+    }
   if (!isNaN (statSum->getSqrSum ()))
-    OutputSingleton (key,variable+"-sqrsum", statSum->getSqrSum ());
+    {
+      OutputSingleton (key,variable + "-sqrsum", statSum->getSqrSum ());
+    }
   if (!isNaN (statSum->getStddev ()))
-    OutputSingleton (key,variable+"-stddev", statSum->getStddev ());
+    {
+      OutputSingleton (key,variable + "-stddev", statSum->getStddev ());
+    }
 }
 
 
@@ -238,11 +185,11 @@
 {
   NS_LOG_FUNCTION (this << key << variable << val);
 
-  sqlite3_reset (m_insertSingletonStatement);
-  sqlite3_bind_text (m_insertSingletonStatement, 2, key.c_str (), key.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (m_insertSingletonStatement, 3, variable.c_str (), variable.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_int (m_insertSingletonStatement, 4, val);
-  sqlite3_step (m_insertSingletonStatement);
+  m_db->SpinReset (m_insertSingletonStatement);
+  m_db->Bind (m_insertSingletonStatement, 2, key);
+  m_db->Bind (m_insertSingletonStatement, 3, variable);
+  m_db->Bind (m_insertSingletonStatement, 4, val);
+  m_db->SpinStep (m_insertSingletonStatement);
 }
 void
 SqliteDataOutput::SqliteOutputCallback::OutputSingleton (std::string key,
@@ -251,11 +198,11 @@
 {
   NS_LOG_FUNCTION (this << key << variable << val);
 
-  sqlite3_reset (m_insertSingletonStatement);
-  sqlite3_bind_text (m_insertSingletonStatement, 2, key.c_str (), key.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (m_insertSingletonStatement, 3, variable.c_str (), variable.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_int64 (m_insertSingletonStatement, 4, val);
-  sqlite3_step (m_insertSingletonStatement);
+  m_db->SpinReset (m_insertSingletonStatement);
+  m_db->Bind (m_insertSingletonStatement, 2, key);
+  m_db->Bind (m_insertSingletonStatement, 3, variable);
+  m_db->Bind (m_insertSingletonStatement, 4, val);
+  m_db->SpinStep (m_insertSingletonStatement);
 }
 
 void
@@ -265,11 +212,11 @@
 {
   NS_LOG_FUNCTION (this << key << variable << val);
 
-  sqlite3_reset (m_insertSingletonStatement);
-  sqlite3_bind_text (m_insertSingletonStatement, 2, key.c_str (), key.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (m_insertSingletonStatement, 3, variable.c_str (), variable.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_double (m_insertSingletonStatement, 4, val);
-  sqlite3_step (m_insertSingletonStatement);
+  m_db->SpinReset (m_insertSingletonStatement);
+  m_db->Bind (m_insertSingletonStatement, 2, key);
+  m_db->Bind (m_insertSingletonStatement, 3, variable);
+  m_db->Bind (m_insertSingletonStatement, 4, val);
+  m_db->SpinStep (m_insertSingletonStatement);
 }
 
 void
@@ -279,11 +226,11 @@
 {
   NS_LOG_FUNCTION (this << key << variable << val);
 
-  sqlite3_reset (m_insertSingletonStatement);
-  sqlite3_bind_text (m_insertSingletonStatement, 2, key.c_str (), key.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (m_insertSingletonStatement, 3, variable.c_str (), variable.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (m_insertSingletonStatement, 4, val.c_str (), val.length (), SQLITE_TRANSIENT);
-  sqlite3_step (m_insertSingletonStatement);
+  m_db->SpinReset (m_insertSingletonStatement);
+  m_db->Bind (m_insertSingletonStatement, 2, key);
+  m_db->Bind (m_insertSingletonStatement, 3, variable);
+  m_db->Bind (m_insertSingletonStatement, 4, val);
+  m_db->SpinStep (m_insertSingletonStatement);
 }
 
 void
@@ -293,9 +240,11 @@
 {
   NS_LOG_FUNCTION (this << key << variable << val);
 
-  sqlite3_reset (m_insertSingletonStatement);
-  sqlite3_bind_text (m_insertSingletonStatement, 2, key.c_str (), key.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_text (m_insertSingletonStatement, 3, variable.c_str (), variable.length (), SQLITE_TRANSIENT);
-  sqlite3_bind_int64 (m_insertSingletonStatement, 4, val.GetTimeStep ());
-  sqlite3_step (m_insertSingletonStatement);
+  m_db->SpinReset (m_insertSingletonStatement);
+  m_db->Bind (m_insertSingletonStatement, 2, key);
+  m_db->Bind (m_insertSingletonStatement, 3, variable);
+  m_db->Bind (m_insertSingletonStatement, 4, val.GetTimeStep ());
+  m_db->SpinStep (m_insertSingletonStatement);
 }
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/stats/model/sqlite-data-output.h ns-3.31/src/stats/model/sqlite-data-output.h
--- ns-3.30.1/src/stats/model/sqlite-data-output.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/stats/model/sqlite-data-output.h	2020-06-27 17:38:30.000000000 -0700
@@ -25,12 +25,12 @@
 
 #include "data-output-interface.h"
 
-#define STATS_HAS_SQLITE3
 
-#include <sqlite3.h>
+struct sqlite3_stmt;
 
 namespace ns3 {
 
+class SQLiteOutput;
 //------------------------------------------------------------
 //--------------------------------------------
 /**
@@ -38,21 +38,19 @@
  * \class SqliteDataOutput
  * \brief Outputs data in a format compatible with SQLite
  */
-class SqliteDataOutput : public DataOutputInterface {
+class SqliteDataOutput : public DataOutputInterface
+{
 public:
-  SqliteDataOutput();
-  virtual ~SqliteDataOutput();
+  SqliteDataOutput ();
+  virtual ~SqliteDataOutput () override;
 
   /**
    * Register this type.
    * \return The TypeId.
    */
   static TypeId GetTypeId (void);
-  
-  virtual void Output (DataCollector &dc);
 
-protected:
-  virtual void DoDispose ();
+  virtual void Output (DataCollector &dc) override;
 
 private:
   /**
@@ -60,14 +58,15 @@
    *
    * \brief Class to generate OMNeT output
    */
-  class SqliteOutputCallback : public DataOutputCallback {
+  class SqliteOutputCallback : public DataOutputCallback
+  {
 public:
     /**
      * Constructor
      * \param owner pointer to the instance this object belongs to
      * \param run experiment descriptor
      */
-    SqliteOutputCallback(Ptr<SqliteDataOutput> owner, std::string run);
+    SqliteOutputCallback (const Ptr<SQLiteOutput> &db, std::string run);
 
     /**
      * Destructor
@@ -135,28 +134,18 @@
                           Time val);
 
 private:
-    Ptr<SqliteDataOutput> m_owner; //!< the instance this object belongs to
+    Ptr<SQLiteOutput> m_db; //!< Db
     std::string m_runLabel; //!< Run label
-    sqlite3_stmt *m_insertSingletonStatement; //!< Prepared singleton insert statement
-
-    // end class SqliteOutputCallback
-  };
 
 
-  sqlite3 *m_db; //!< pointer to the SQL database
-
-  /**
-   * \brief Execute a sqlite3 query
-   * \param exe the query to execute
-   * \return sqlite return code.
-   */
-  int Exec (std::string exe);
+    sqlite3_stmt *m_insertSingletonStatement;
+  };
 
-  // end class SqliteDataOutput
+  Ptr<SQLiteOutput> m_sqliteOut; //!< Database
 };
 
 // end namespace ns3
-};
+}
 
 
 #endif /* SQLITE_DATA_OUTPUT_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/stats/model/sqlite-output.cc ns-3.31/src/stats/model/sqlite-output.cc
--- ns-3.30.1/src/stats/model/sqlite-output.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/stats/model/sqlite-output.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,465 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+#include "sqlite-output.h"
+#include <sys/stat.h>
+#include <fcntl.h>
+#include "ns3/abort.h"
+#include "ns3/unused.h"
+#include "ns3/log.h"
+#include "ns3/nstime.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("SQLiteOutput");
+
+SQLiteOutput::SQLiteOutput (const std::string &name, const std::string &semName)
+  : m_semName (semName)
+{
+  int rc = sqlite3_open (name.c_str (), &m_db);
+  NS_ABORT_MSG_UNLESS (rc == SQLITE_OK, "Failed to open DB");
+}
+
+SQLiteOutput::~SQLiteOutput ()
+{
+  int rc = SQLITE_FAIL;
+
+  rc = sqlite3_close_v2 (m_db);
+  NS_ABORT_MSG_UNLESS (rc == SQLITE_OK, "Failed to close DB");
+}
+
+void
+SQLiteOutput::SetJournalInMemory ()
+{
+  NS_LOG_FUNCTION (this);
+  SpinExec ("PRAGMA journal_mode = MEMORY");
+}
+
+bool
+SQLiteOutput::SpinExec (const std::string &cmd) const
+{
+  return (SpinExec (m_db, cmd) == SQLITE_OK);
+}
+
+bool
+SQLiteOutput::SpinExec (sqlite3_stmt *stmt) const
+{
+  int rc = SpinExec (m_db, stmt);
+  return !CheckError (m_db, rc, "", nullptr, false);
+}
+
+bool
+SQLiteOutput::WaitExec (const std::string &cmd) const
+{
+  int rc = WaitExec (m_db, cmd);
+  return !CheckError (m_db, rc, cmd, nullptr, false);
+}
+
+bool
+SQLiteOutput::WaitExec (sqlite3_stmt *stmt) const
+{
+  return (WaitExec (m_db, stmt) == SQLITE_OK);
+}
+
+bool
+SQLiteOutput::WaitPrepare (sqlite3_stmt **stmt, const std::string &cmd) const
+{
+  return (WaitPrepare (m_db, stmt, cmd) == SQLITE_OK);
+}
+
+bool
+SQLiteOutput::SpinPrepare (sqlite3_stmt **stmt, const std::string &cmd) const
+{
+  return (SpinPrepare (m_db, stmt, cmd) == SQLITE_OK);
+}
+
+template<typename T>
+T
+SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
+{
+  NS_UNUSED (stmt);
+  NS_UNUSED (pos);
+  NS_FATAL_ERROR ("Can't call generic fn");
+}
+
+template<>
+int
+SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
+{
+  return sqlite3_column_int (stmt, pos);
+}
+
+template<>
+uint32_t
+SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
+{
+  return static_cast<uint32_t> (sqlite3_column_int (stmt, pos));
+}
+
+template<>
+double
+SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
+{
+  return sqlite3_column_double (stmt, pos);
+}
+
+template<typename T>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const T &value) const
+{
+  NS_UNUSED (stmt);
+  NS_UNUSED (pos);
+  NS_UNUSED (value);
+  NS_FATAL_ERROR ("Can't call generic fn");
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const Time &value) const
+{
+  if (sqlite3_bind_double (stmt, pos, value.GetSeconds ()) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const double &value) const
+{
+  if (sqlite3_bind_double (stmt, pos, value) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const uint32_t &value) const
+{
+  if (sqlite3_bind_int (stmt, pos, static_cast<int> (value)) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const long &value) const
+{
+  if (sqlite3_bind_int64 (stmt, pos, value) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const long long &value) const
+{
+  if (sqlite3_bind_int64 (stmt, pos, value) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const uint16_t &value) const
+{
+  if (sqlite3_bind_int (stmt, pos, static_cast<int> (value)) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const uint8_t &value) const
+{
+  if (sqlite3_bind_int (stmt, pos, static_cast<int> (value)) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const int &value) const
+{
+  if (sqlite3_bind_int (stmt, pos, value) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+template<>
+bool
+SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const std::string &value) const
+{
+  if (sqlite3_bind_text (stmt, pos, value.c_str (), -1, SQLITE_STATIC) == SQLITE_OK)
+    {
+      return true;
+    }
+  return false;
+}
+
+int
+SQLiteOutput::WaitPrepare (sqlite3 *db, sqlite3_stmt **stmt, const std::string &cmd) const
+{
+  int rc;
+  bool ret;
+  sem_t *sem = sem_open (m_semName.c_str (), O_CREAT, S_IRUSR | S_IWUSR, 1);
+
+  NS_ABORT_MSG_IF (sem == SEM_FAILED,
+                   "FAILED to open system semaphore, errno: " << errno);
+
+  if (sem_wait (sem) == 0)
+    {
+      rc = sqlite3_prepare_v2 (db, cmd.c_str (),
+                               static_cast<int> (cmd.size ()),
+                               stmt, nullptr);
+
+      ret = CheckError (db, rc, cmd, sem, false);
+      if (ret)
+        {
+          return rc;
+        }
+
+      sem_post (sem);
+    }
+  else
+    {
+      NS_FATAL_ERROR ("Can't lock semaphore");
+    }
+
+  sem_close (sem);
+  sem = nullptr;
+
+  return rc;
+}
+
+int
+SQLiteOutput::SpinPrepare (sqlite3 *db, sqlite3_stmt **stmt, const std::string &cmd)
+{
+  int rc;
+
+  do
+    {
+      rc = sqlite3_prepare_v2 (db, cmd.c_str (),
+                               static_cast<int> (cmd.size ()),
+                               stmt, nullptr);
+    }
+  while (rc == SQLITE_BUSY || rc == SQLITE_LOCKED);
+  return rc;
+}
+
+int
+SQLiteOutput::SpinStep (sqlite3_stmt *stmt)
+{
+  int rc;
+  do
+    {
+      rc = sqlite3_step (stmt);
+    }
+  while (rc == SQLITE_BUSY || rc == SQLITE_LOCKED);
+
+  return rc;
+}
+
+int
+SQLiteOutput::SpinFinalize (sqlite3_stmt *stmt)
+{
+  int rc;
+  do
+    {
+      rc = sqlite3_finalize (stmt);
+    }
+  while (rc == SQLITE_BUSY || rc == SQLITE_LOCKED);
+
+  return rc;
+}
+
+int SQLiteOutput::SpinReset (sqlite3_stmt *stmt)
+{
+  int rc;
+
+  do
+    {
+      rc = sqlite3_reset (stmt);
+    }
+  while (rc == SQLITE_BUSY || rc == SQLITE_LOCKED);
+
+  return rc;
+}
+
+void
+SQLiteOutput::Error (sqlite3 *db, const std::string &cmd)
+{
+  NS_ABORT_MSG (cmd << " error " << sqlite3_errmsg (db));
+}
+
+bool
+SQLiteOutput::CheckError (sqlite3 *db, int rc, const std::string &cmd,
+                          sem_t *sem, bool hardExit)
+{
+  if (rc != SQLITE_OK && rc != SQLITE_DONE)
+    {
+      if (sem != nullptr)
+        {
+          sem_post (sem);
+          sem_close (sem);
+        }
+      if (hardExit)
+        {
+          Error (db, cmd);
+        }
+      else
+        {
+          std::cerr << sqlite3_errmsg (db) << std::endl;
+        }
+      return true;
+    }
+  return false;
+}
+
+int
+SQLiteOutput::SpinExec (sqlite3 *db, const std::string &cmd)
+{
+  sqlite3_stmt *stmt;
+  bool ret;
+
+  int rc = SpinPrepare (db, &stmt, cmd);
+  ret = CheckError (db, rc, cmd, nullptr, false);
+  if (ret)
+    {
+      return rc;
+    }
+
+  rc = SpinStep (stmt);
+  ret = CheckError (db, rc, cmd, nullptr, false);
+  if (ret)
+    {
+      return rc;
+    }
+
+  rc = SpinFinalize (stmt);
+  CheckError (db, rc, cmd, nullptr, false);
+
+  return rc;
+}
+
+int
+SQLiteOutput::SpinExec (sqlite3 *db, sqlite3_stmt *stmt)
+{
+  bool ret;
+  int rc = SpinStep (stmt);
+  ret = CheckError (db, rc, "", nullptr, false);
+  if (ret)
+    {
+      return rc;
+    }
+
+  rc = SpinFinalize (stmt);
+  return rc;
+}
+
+int
+SQLiteOutput::WaitExec (sqlite3 *db, sqlite3_stmt *stmt) const
+{
+  bool ret;
+  int rc = SQLITE_ERROR;
+
+  sem_t *sem = sem_open (m_semName.c_str (), O_CREAT, S_IRUSR | S_IWUSR, 1);
+
+  NS_ABORT_MSG_IF (sem == SEM_FAILED,
+                   "FAILED to open system semaphore, errno: " << errno);
+
+  if (sem_wait (sem) == 0)
+    {
+      rc = SpinStep (stmt);
+
+      ret = CheckError (db, rc, "", sem, false);
+      if (ret)
+        {
+          return rc;
+        }
+
+      rc = SpinFinalize (stmt);
+
+      sem_post (sem);
+    }
+  else
+    {
+      NS_FATAL_ERROR ("Can't lock system semaphore");
+    }
+
+  sem_close (sem);
+
+  return rc;
+}
+
+int
+SQLiteOutput::WaitExec (sqlite3 *db, const std::string &cmd) const
+{
+  sqlite3_stmt *stmt;
+  bool ret;
+  int rc = SQLITE_ERROR;
+
+  sem_t *sem = sem_open (m_semName.c_str (), O_CREAT, S_IRUSR | S_IWUSR, 1);
+
+  NS_ABORT_MSG_IF (sem == SEM_FAILED,
+                   "FAILED to open system semaphore, errno: " << errno);
+
+  if (sem_wait (sem) == 0)
+    {
+      rc = SpinPrepare (db, &stmt, cmd);
+      ret = CheckError (db, rc, cmd, sem, false);
+      if (ret)
+        {
+          return rc;
+        }
+
+      rc = SpinStep (stmt);
+
+      ret = CheckError (db, rc, cmd, sem, false);
+      if (ret)
+        {
+          return rc;
+        }
+
+      rc = SpinFinalize (stmt);
+
+      sem_post (sem);
+    }
+
+  sem_close (sem);
+
+  return rc;
+}
+
+} // namespace ns3;
